<template>
  <div class="Table">
    <!-- 按钮 -->
    <AddButton @add="add"></AddButton>
    <!-- 表格 -->
    <Table :list="datas.tableData" @handleDelete="handleDelete" @handleEdit="handleEdit"></Table>
    <!-- 分页 -->
    <Paging :pagingConfig="datas.pagingConfig" @sizeChange="sizeChange" @currentChange="currentChange"></Paging>
    <!-- 其他模板 -->
    <!-- 新增/编辑 -->
    <myDialog ref="myDialogRef" :title="datas.title" @confirm="confirm" width="30%">
      <el-form ref="ruleFormRef" :rules="datas.rules" :model="datas.DialogForm" label-width="80px">
        <el-form-item label="奖品类型">
          <el-radio-group v-model="datas.DialogForm.goodsCategory">
            <el-radio label="实物" value="physical" />
            <el-radio label="优惠劵" value="coupon" />
          </el-radio-group>
        </el-form-item>
        <el-form-item label="商品图片" required prop="goodsImageUrl">
          <div style="display: flex; flex-wrap: wrap">
            <div v-for="(item, index) in datas.DialogForm.goodsImageUrl" :key="index" style="position: relative"
              class="showStyle">
              <el-icon class="buttonstyle" @click="deleteEvent(item)">
                <DeleteFilled />
              </el-icon>
              <img style="width: 148px; height: 148px; margin-right: 6px" class="imgStyle" :src="item" alt="" />
            </div>
            <div class="upImgStyle" @click="addimgEvent">+</div>
          </div>
        </el-form-item>
        <el-form-item label="商品名称">
          <el-input v-model="datas.DialogForm.goodsName" placeholder="请输入商品名称" />
        </el-form-item>
        <el-form-item label="所需积分">
          <el-col :span="10">
            <el-input v-model="datas.DialogForm.requiredPoints" type="number" placeholder="">
              <template #append>积分</template>
            </el-input>
          </el-col>
        </el-form-item>
        <el-form-item label="额外价格">
          <el-col :span="10">
            <el-input v-model="datas.DialogForm.extraPrice" type="number" placeholder="">
              <template #append>元</template>
            </el-input>
          </el-col>
        </el-form-item>
        <el-form-item label="数量">
          <el-input-number v-model="datas.DialogForm.quantity" />
        </el-form-item>
        <el-form-item label="排序">
          <el-input-number v-model="datas.DialogForm.sort" />
        </el-form-item>
        <el-form-item label="是否上架">
          <el-switch v-model="datas.DialogForm.status" :active-value="1" :inactive-value="0" />
        </el-form-item>
      </el-form>
    </myDialog>
    <!-- 选择图片 -->
    <AddImg ref="addImg" @successEvent="successEvent"></AddImg>
  </div>
</template>
<script setup>
import AddButton from './component/AddButton.vue'
import Table from './component/Table.vue'
import Paging from './component/Paging.vue'
import myDialog from '@/components/mycomponents/myDialog.vue'
import eventBus from '@/utils/eventBus'
import API from './api'

const datas = reactive({
  tableData: [], // 表格数据
  title: '新增数据',
  pagingConfig: {
    total: 0, // 总数
    pageSize: 10, // 每页数据数量
    pageNumber: 1, // 当前页码
  },
  DialogForm: { // 弹窗表单数据
    goodsCategory: 'physical',
    goodsName: '',
    requiredPoints: 0,
    extraPrice: 0,
    quantity: 1,
    sort: 1,
    status: 1,
    goodsImageUrl: []
  },
  rules: {
    name: [
      { required: true, message: '请输入供应商名称', trigger: 'blur' },
      { min: 3, max: 5, message: 'Length should be 3 to 5', trigger: 'blur' },
    ],
  }
})
const myDialogRef = ref(null)
const ruleFormRef = ref(null)
onMounted(() => {
  getList()
})


async function getList(data = {}) {
  const res = await API.getPage({ page: datas.pagingConfig.pageNumber, size: datas.pagingConfig.pageSize, ...data })
  datas.tableData = res.records
  datas.pagingConfig.total = res.totalRow
  datas.pagingConfig.pageSize = res.pageSize
  datas.pagingConfig.pageNumber = res.pageNumber
}
function add() {
  if (datas.DialogForm.id) {
    rest()
  }
  datas.title = '新增数据'
  myDialogRef.value.open()
}
async function handleEdit(row) {
  datas.title = '编辑数据'
  const res = await API.getinfo(row.id)
  datas.DialogForm = res
  // 有图片
  datas.DialogForm.goodsImageUrl = res.goodsImageUrl.split(',')
  myDialogRef.value.open()
}
async function confirm() {
  ruleFormRef.value.validate(async valid => {
    if (valid) {
      let res = null
      if (datas.title == '新增数据') {
        // 图片处理
        datas.DialogForm.goodsImageUrl = datas.DialogForm.goodsImageUrl.join(',')
        res = await API.add(datas.DialogForm)
      } else {
        datas.DialogForm.goodsImageUrl = datas.DialogForm.goodsImageUrl.join(',')
        res = await API.update(datas.DialogForm)
      }
      if (res) {
        ElMessage({
          message: '成功',
          type: 'success',
        })
        rest()
        getList()
        myDialogRef.value.close()
      }
    }
  })
}
// 重置
function rest() {
  datas.DialogForm = {
    goodsCategory: 'physical',
    goodsName: '',
    requiredPoints: 0,
    extraPrice: 0,
    quantity: 1,
    sort: 1,
    status: 1,
    goodsImageUrl: []
  }
}
async function handleDelete(id) {
  ElMessageBox.confirm("是否删除数据项?", "提示", {
    confirmButtonText: "确定",
    cancelButtonText: "取消",
    type: "warning",
  }).then(
    async () => {
      let res = await API.deleteByIds(id)
      if (res.code == 200) {
        ElMessage({
          message: '删除成功',
          type: 'success',
        })
        getList()
      }
    }
  );
}
// 图片
const addImg = ref(null)
function addimgEvent() {
  (addImg.value)?.show()
}
function successEvent(d) {
  datas.DialogForm['goodsImageUrl'].push(d[0].url);
}
function deleteEvent(d) {
  let index = datas.DialogForm.goodsImageUrl.findIndex((ele) => ele == d);
  datas.DialogForm.goodsImageUrl.splice(index, 1);
}
// 分页
function sizeChange(val) {
  datas.pagingConfig.pageSize = val
  getList()
}
function currentChange(val) {
  datas.pagingConfig.pageNumber = val
  getList()
}

</script>
<style scoped lang="scss">
.Table {
  padding: 20px;
  background-color: #fff;
  border: 1px solid #e4e7ed;
  margin-top: 20px;
  border-radius: 4px;
}

// 图片库样式
.upImgStyle {
  cursor: pointer;
  width: 148px;
  height: 148px;
  line-height: 148px;
  text-align: center;
  border: 1px dashed #ccc;
  border-radius: 1%;
  font-size: 30px;
  color: #ccc;
}

.buttonstyle {
  border-radius: 50%;
  color: #db1616;
  background-color: #fff;
  font-size: 20px;
  display: none;
  position: absolute;
  right: 0px;
  top: -10px;
  z-index: 10;
}
</style>